# -*- coding: utf-8 -*-
"""
Created on Sun Sep 07 23:07:24 2014

@author: MMO  Curso de graficado FCC BUAPO 2014
"""

import sys, math
from PyQt4 import QtGui, QtCore


# clase ZonaDibujo
class ZonaDibujo(QtGui.QWidget):
    def __init__(self):
        super(ZonaDibujo, self).__init__()
        self.initUI()
        
    def initUI(self):
        self.setGeometry(50,50,300,300)
        self.setWindowTitle('Estrellas ...')
        self.setMaximumWidth(600)
        self.setMaximumHeight(600)
        self.setMinimumWidth(100)
        self.setMinimumHeight(100)        
        
        self.valor  = 3
        self.estilo = 0
        
    def setValor(self,valor):
        self.valor = valor
        print 'valor= ',valor
        
    def setEstilo(self,estilo):
        self.estilo = estilo
        print 'estilo= ',estilo

    def paintEvent(self, e):
        print 'Dentro de paintEvent de ZonaDibujo...'
        qp = QtGui.QPainter()
        qp.begin(self)
        self.drawGrafica(qp)
        qp.end()            
        
    def drawGrafica(self, qp):
        print 'Dibujando en la ZD...'
        size = self.size()
        w    = size.width()
        h    = size.height()
        mar  = 10      
        
        N  = self.valor
        EE = self.estilo
        
        print 'N= ', N
        print 'E= ', EE
        
        xm = w // 2
        ym = h // 2
        
        R = xm
        if (R>ym):
            R = ym
        print 'R= ', R
        
        R1 = 0.9*R
        R2 = 0.2*R
        
        t  = 0
        dt = 2*math.pi/N
        dq = dt/2
        
        brush = QtGui.QBrush(QtGui.QColor(200,0,0))
        qp.setBrush(brush)
        
        pen =  QtGui.QPen(QtCore.Qt.green, 1, QtCore.Qt.SolidLine)   
        qp.setPen(pen)
        
        qp.drawRect(mar, mar, w-2*mar, h-2*mar)        
            
        if (EE==0):        
            for k in range(N):
                x = xm + R1*math.cos(t)
                y = ym + R1*math.sin(t)
                qp.drawLine(xm,ym,x,y)
                t += dt
        
        if (EE==1):
            for k in range(N):
                x = xm + R1*math.cos(t)
                y = ym + R1*math.sin(t)
                
                t1 = t - dq
                x1 = xm + R2*math.cos(t1)
                y1 = ym + R2*math.sin(t1)

                t2 = t + dq
                x2 = xm + R2*math.cos(t2)
                y2 = ym + R2*math.sin(t2)
                
                qp.drawLine(x1,y1,x,y)
                qp.drawLine(x2,y2,x,y)
                
                t += dt    
            

# clase Principal
class Principal(QtGui.QWidget):
    
    def __init__(self):
        super(Principal, self).__init__()
        self.initUI()
        
    def initUI(self):    
        self.label1 = QtGui.QLabel('Puntas', self)
#        self.label1.move(20,40)
        
        self.texto1 = QtGui.QLineEdit('3', self)
        self.texto1.setFixedWidth(30)
#        self.texto1.move(80,40)        
        
        self.boton1 = QtGui.QPushButton('Dibuja', self)
#        self.boton1.move(120,40)
        self.boton1.clicked.connect(self.onClicked)
        
        self.combo = QtGui.QComboBox(self)
        self.combo.addItem('Simple')
        self.combo.addItem('Estrella')
#        self.combo.move(200,40)     
        self.combo.activated[str].connect(self.onActivated)
        
        # acomodando los elementos
        boxHoriz = QtGui.QHBoxLayout()
        boxHoriz.addStretch(1)
        boxHoriz.addWidget(self.label1)
        boxHoriz.addWidget(self.texto1)        
        boxHoriz.addWidget(self.boton1)        
        boxHoriz.addWidget(self.combo)        
        self.setLayout(boxHoriz)
        
        # abre la ventana de dibujo
        self.zd     = ZonaDibujo()
        self.zd.move(400,20)
        self.zd.show()
                      
        # muestr la ventana de esta clase
        self.setGeometry(50,50,250,80)
        self.setWindowTitle('Ventana de Dibujo Externa FCC 2014')
        self.show()
        
       
    def onClicked(self):
        picos = int(self.texto1.text())
        self.zd.setValor(picos)
        self.zd.repaint()
   
    def onActivated(self):
        opc = self.combo.currentIndex()
        self.zd.setEstilo(opc)
        self.zd.repaint()
      
    def closeEvent(self, event):
        self.zd.close()
        
        
def main():
    app = QtGui.QApplication(sys.argv)
    ejem = Principal()
    sys.exit(app.exec_())
    
    
if __name__ == '__main__':
    main()     
        
        
            
            