# -*- coding: utf-8 -*-
"""
Created on Mon Sep 02 20:25:11 2014

@author: MAQUINA

Ejemplo de captura de datos para un gráfico

"""

import sys
import math
from PyQt4 import QtGui, QtCore


class Example(QtGui.QMainWindow):
    
    def __init__(self):
        super(Example, self).__init__()
        
        
        self.initUI()
        
    def initUI(self):      

        self.qp = QtGui.QPainter()
        
        self.setGeometry(100, 100, 400, 500)
        self.setMaximumWidth(400)
        self.setMaximumHeight(500)
        self.setMinimumWidth(400)
        self.setMinimumHeight(500)

        self.setWindowTitle('Espiral de Arquimedes FCC 2014')
        self.show()
        
    # Painter
    def paintEvent(self, e):

        self.qp.begin(self)
                
        ZonaTrab = QtCore.QRect(-10,-50,300,300)
        self.qp.setWindow(ZonaTrab)

        brush = QtGui.QBrush(QtCore.Qt.SolidPattern)
        self.qp.setBrush(brush)
        self.qp.drawRect(0, 0, 280, 240)

        self.funcion(self.qp)

        self.qp.end()

    def funcion(self, qp):
        # ejes
        pen = QtGui.QPen(QtCore.Qt.white, 1, QtCore.Qt.DashLine)

        qp.setPen(pen)
        
        qp.drawLine(  5, 120, 275, 120)
        qp.drawLine(140,   5, 140, 235)
        
        qp.drawText(150,20,'Y')
        qp.drawText(270,110,'X')
        
        # espiral
        pen = QtGui.QPen(QtCore.Qt.green, 1, QtCore.Qt.SolidLine)
        pen.setStyle(QtCore.Qt.SolidLine)
        qp.setPen(pen)
        N = 30
        M = 8
        t = 0
        dt = 2*math.pi/N
        
        k = 10/(2*math.pi)

        for i in range(M):
            x1 = 140 + k*t*math.cos(t)
            y1 = 120 + k*t*math.sin(t)
           
            for j in range(N):
                t = t + dt                
                x2 = 140 + k*t*math.cos(t)
                y2 = 120 + k*t*math.sin(t)
                
                qp.drawLine(x1, y1, x2, y2)
                x1 = x2
                y1 = y2
        
        
def main():
    
    app = QtGui.QApplication(sys.argv)
    ex = Example()
    sys.exit(app.exec_())


if __name__ == '__main__':
    main()


