# -*- coding: utf-8 -*-
"""
Created on Wed Sep 03 09:27:47 2014

@author: manuel
"""

import sys, math
from PyQt4 import QtGui, QtCore


class Example(QtGui.QWidget):
    
    def __init__(self):
        super(Example, self).__init__()
        
        self.initUI()
        
    def initUI(self):      

        self.btn = QtGui.QPushButton('Dialog', self)
        self.btn.move(20, 20)
        self.btn.clicked.connect(self.showDialog)
        
        self.le = QtGui.QLineEdit(self)
        self.le.move(130, 22)
        
        self.setGeometry(100, 50, 400, 400)
        self.setMaximumHeight(400)
        self.setMinimumHeight(400)
        self.setMaximumWidth(400)
        self.setMinimumWidth(400)
        
        
        self.setWindowTitle('Input dialog')
        self.show()
        
    def showDialog(self):
        
        text, ok = QtGui.QInputDialog.getText(self, 'Input Dialog', 
            'Enter your name:')
        
        if ok:
            self.le.setText(str(text))
            
    # repinta la interface cuando es necesario            
    def paintEvent(self, e):
        qp = QtGui.QPainter()
        qp.begin(self)
        self.espiral(qp)
        qp.end()

    def espiral(self,qp):
        # linea divisoria
        x1 = 20
        y1 = 60
        x2 = 380
        y2 = 60
        qp.drawLine(x1,y1,x2,y2)
        # rectangulo gris   
        colorP = QtGui.QColor(40, 40, 200)
        qp.setPen(colorP)
        colorB = QtGui.QColor(150, 150, 150)
        qp.setBrush(colorB)
        qp.drawRect(20, 65, 360, 320)
        # ejes coordenados
        colorE = QtGui.QColor(40, 200, 40)        
        qp.setPen(colorE)
        qp.drawLine(25,225,375,225) # eje X
        qp.drawLine(200,70,200,380) # eje Y
        
        # La espiral
        colorT = QtGui.QColor(200, 200, 200)        
        qp.setPen(colorT)
        Nv = 8
        Np = 60
        
        k = 15/(2*math.pi)
        x0 = 200
        y0 = 225
        
        x1 = 0 + x0
        y1 = 0 + y0
        th = 0
        dt = 2*math.pi/Np
        ban = True        
        
        
        for i in range(Nv):
            for j in range(Np):
                th = th + dt
                x2 =  k*th*math.cos(th) + x0
                y2 = -k*th*math.sin(th) + y0
                qp.drawLine(x1,y1,x2,y2)
                x1 = x2
                y1 = y2
                if ban:
                    qp.setPen(QtCore.Qt.black)
                    ban = False
                else:
                    qp.setPen(colorT)
                    ban = True
                    
        
def main():
    
    app = QtGui.QApplication(sys.argv)
    ex = Example()
    sys.exit(app.exec_())


if __name__ == '__main__':
    main()
